"""
    Agent API

    This document refers to Symphony API calls to send and receive messages and content. They need the on-premise Agent installed to perform decryption/encryption of content.  - sessionToken and keyManagerToken can be obtained by calling the authenticationAPI on the symphony back end and the key manager respectively. Refer to the methods described in authenticatorAPI.yaml. - Actions are defined to be atomic, ie will succeed in their entirety or fail and have changed nothing. - If it returns a 40X status then it will have sent no message to any stream even if a request to some subset of the requested streams would have succeeded. - If this contract cannot be met for any reason then this is an error and the response code will be 50X. - MessageML is a markup language for messages. See reference here: https://rest-api.symphony.com/docs/messagemlv2 - **Real Time Events**: The following events are returned when reading from a real time messages and events stream (\"datafeed\"). These events will be returned for datafeeds created with the v5 endpoints. To know more about the endpoints, refer to Create Messages/Events Stream and Read Messages/Events Stream. Unless otherwise specified, all events were added in 1.46.   # noqa: E501

    The version of the OpenAPI document: 22.9.1
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Union

from symphony.bdk.gen.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from symphony.bdk.gen.exceptions import ApiAttributeError


from symphony.bdk.gen.agent_model.v1_dlp_content_type import V1DLPContentType
from symphony.bdk.gen.agent_model.v1_dlp_matched_policy_list import V1DLPMatchedPolicyList
from symphony.bdk.gen.agent_model.v1_dlp_outcome import V1DLPOutcome
globals()['V1DLPContentType'] = V1DLPContentType
globals()['V1DLPMatchedPolicyList'] = V1DLPMatchedPolicyList
globals()['V1DLPOutcome'] = V1DLPOutcome

class V1DLPViolation(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a agent_model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a agent_model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'enforcement_event_id': (str, none_type),  # noqa: E501
            'entity_id': (str, none_type),  # noqa: E501
            'create_time': (int, none_type),  # noqa: E501
            'last_modified': (int, none_type),  # noqa: E501
            'requester_id': (int, none_type),  # noqa: E501
            'matched_policies': (V1DLPMatchedPolicyList, none_type),  # noqa: E501
            'action': (str, none_type),  # noqa: E501
            'outcome': (V1DLPOutcome, none_type),  # noqa: E501
            'content_type': (V1DLPContentType, none_type),  # noqa: E501
            'version': (str, none_type),  # noqa: E501
            'ignore_dl_pwarning': (bool, none_type),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'enforcement_event_id': 'enforcementEventID',  # noqa: E501
        'entity_id': 'entityID',  # noqa: E501
        'create_time': 'createTime',  # noqa: E501
        'last_modified': 'lastModified',  # noqa: E501
        'requester_id': 'requesterId',  # noqa: E501
        'matched_policies': 'matchedPolicies',  # noqa: E501
        'action': 'action',  # noqa: E501
        'outcome': 'outcome',  # noqa: E501
        'content_type': 'contentType',  # noqa: E501
        'version': 'version',  # noqa: E501
        'ignore_dl_pwarning': 'ignoreDLPwarning',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """V1DLPViolation - a agent_model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the agent_model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            enforcement_event_id (str): Enforcement event ID. Unique ID that identifies this enforcement.. [optional]  # noqa: E501
            entity_id (str): Entity ID is the content Id of the violation, for example, for messages, its the Id of the message. [optional]  # noqa: E501
            create_time (int): Timestamp of the violation in milliseconds since Jan 1 1970. [optional]  # noqa: E501
            last_modified (int): Timestamp of the last modification of violation in milliseconds since Jan 1 1970. [optional]  # noqa: E501
            requester_id (int): Id of the requester responsible for the message/stream/signal. [optional]  # noqa: E501
            matched_policies (V1DLPMatchedPolicyList): [optional]  # noqa: E501
            action (str): action taken such as BLOCK or WARN.  See outcome for a more detailed description of the outcome this action.. [optional]  # noqa: E501
            outcome (V1DLPOutcome): [optional]  # noqa: E501
            content_type (V1DLPContentType): [optional]  # noqa: E501
            version (str): Version of application which processed the message and produced this violation.. [optional]  # noqa: E501
            ignore_dl_pwarning (bool): Did the user chose to ignore DLP warning that was presented?. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """V1DLPViolation - a agent_model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the agent_model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            enforcement_event_id (str): Enforcement event ID. Unique ID that identifies this enforcement.. [optional]  # noqa: E501
            entity_id (str): Entity ID is the content Id of the violation, for example, for messages, its the Id of the message. [optional]  # noqa: E501
            create_time (int): Timestamp of the violation in milliseconds since Jan 1 1970. [optional]  # noqa: E501
            last_modified (int): Timestamp of the last modification of violation in milliseconds since Jan 1 1970. [optional]  # noqa: E501
            requester_id (int): Id of the requester responsible for the message/stream/signal. [optional]  # noqa: E501
            matched_policies (V1DLPMatchedPolicyList): [optional]  # noqa: E501
            action (str): action taken such as BLOCK or WARN.  See outcome for a more detailed description of the outcome this action.. [optional]  # noqa: E501
            outcome (V1DLPOutcome): [optional]  # noqa: E501
            content_type (V1DLPContentType): [optional]  # noqa: E501
            version (str): Version of application which processed the message and produced this violation.. [optional]  # noqa: E501
            ignore_dl_pwarning (bool): Did the user chose to ignore DLP warning that was presented?. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.enforcement_event_id: str = None
        self.entity_id: str = None
        self.create_time: int = None
        self.last_modified: int = None
        self.requester_id: int = None
        self.matched_policies: V1DLPMatchedPolicyList = None
        self.action: str = None
        self.outcome: V1DLPOutcome = None
        self.content_type: V1DLPContentType = None
        self.version: str = None
        self.ignore_dl_pwarning: bool = None
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
