"""
    Symphony Profile Manager

    Profile Manager is a microservice to manage users profile and groups  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Union

from symphony.bdk.gen.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from symphony.bdk.gen.exceptions import ApiAttributeError


from symphony.bdk.gen.group_model.avatar import Avatar
from symphony.bdk.gen.group_model.base_profile import BaseProfile
from symphony.bdk.gen.group_model.profile_all_of import ProfileAllOf
globals()['Avatar'] = Avatar
globals()['BaseProfile'] = BaseProfile
globals()['ProfileAllOf'] = ProfileAllOf

class Profile(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('display_name',): {
            'min_length': 1,
        },
        ('market_coverage',): {
        },
        ('responsibility',): {
        },
        ('function',): {
        },
        ('instrument',): {
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a group_model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a group_model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'display_name': (str, none_type),  # noqa: E501
            'company_name': (str, none_type),  # noqa: E501
            'email': (str, none_type),  # noqa: E501
            'mobile': (str, none_type),  # noqa: E501
            'job_title': (str, none_type),  # noqa: E501
            'job_role': (str, none_type),  # noqa: E501
            'job_department': (str, none_type),  # noqa: E501
            'job_division': (str, none_type),  # noqa: E501
            'job_phone': (str, none_type),  # noqa: E501
            'job_city': (str, none_type),  # noqa: E501
            'industry_of_interest': ([str], none_type),  # noqa: E501
            'asset_classes_of_interest': ([str], none_type),  # noqa: E501
            'market_coverage': ([str], none_type),  # noqa: E501
            'responsibility': ([str], none_type),  # noqa: E501
            'function': ([str], none_type),  # noqa: E501
            'instrument': ([str], none_type),  # noqa: E501
            'id': (str, none_type),  # noqa: E501
            'avatars': ([Avatar], none_type),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'display_name': 'displayName',  # noqa: E501
        'company_name': 'companyName',  # noqa: E501
        'email': 'email',  # noqa: E501
        'mobile': 'mobile',  # noqa: E501
        'job_title': 'jobTitle',  # noqa: E501
        'job_role': 'jobRole',  # noqa: E501
        'job_department': 'jobDepartment',  # noqa: E501
        'job_division': 'jobDivision',  # noqa: E501
        'job_phone': 'jobPhone',  # noqa: E501
        'job_city': 'jobCity',  # noqa: E501
        'industry_of_interest': 'industryOfInterest',  # noqa: E501
        'asset_classes_of_interest': 'assetClassesOfInterest',  # noqa: E501
        'market_coverage': 'marketCoverage',  # noqa: E501
        'responsibility': 'responsibility',  # noqa: E501
        'function': 'function',  # noqa: E501
        'instrument': 'instrument',  # noqa: E501
        'id': 'id',  # noqa: E501
        'avatars': 'avatars',  # noqa: E501
    }

    read_only_vars = {
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """Profile - a group_model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the group_model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            display_name (str): The display name in Directory, it is expected to be the same as group name. [optional]  # noqa: E501
            company_name (str): The company name is expected to be the same as group company owner. [optional]  # noqa: E501
            email (str): [optional]  # noqa: E501
            mobile (str): [optional]  # noqa: E501
            job_title (str): [optional]  # noqa: E501
            job_role (str): [optional]  # noqa: E501
            job_department (str): [optional]  # noqa: E501
            job_division (str): [optional]  # noqa: E501
            job_phone (str): [optional]  # noqa: E501
            job_city (str): [optional]  # noqa: E501
            industry_of_interest ([str]): [optional]  # noqa: E501
            asset_classes_of_interest ([str]): [optional]  # noqa: E501
            market_coverage ([str]): [optional]  # noqa: E501
            responsibility ([str]): [optional]  # noqa: E501
            function ([str]): [optional]  # noqa: E501
            instrument ([str]): [optional]  # noqa: E501
            id (str): Profile unique identifier. [optional]  # noqa: E501
            avatars ([Avatar]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """Profile - a group_model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the group_model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            display_name (str): The display name in Directory, it is expected to be the same as group name. [optional]  # noqa: E501
            company_name (str): The company name is expected to be the same as group company owner. [optional]  # noqa: E501
            email (str): [optional]  # noqa: E501
            mobile (str): [optional]  # noqa: E501
            job_title (str): [optional]  # noqa: E501
            job_role (str): [optional]  # noqa: E501
            job_department (str): [optional]  # noqa: E501
            job_division (str): [optional]  # noqa: E501
            job_phone (str): [optional]  # noqa: E501
            job_city (str): [optional]  # noqa: E501
            industry_of_interest ([str]): [optional]  # noqa: E501
            asset_classes_of_interest ([str]): [optional]  # noqa: E501
            market_coverage ([str]): [optional]  # noqa: E501
            responsibility ([str]): [optional]  # noqa: E501
            function ([str]): [optional]  # noqa: E501
            instrument ([str]): [optional]  # noqa: E501
            id (str): Profile unique identifier. [optional]  # noqa: E501
            avatars ([Avatar]): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]
        self.display_name: str = None
        self.company_name: str = None
        self.email: str = None
        self.mobile: str = None
        self.job_title: str = None
        self.job_role: str = None
        self.job_department: str = None
        self.job_division: str = None
        self.job_phone: str = None
        self.job_city: str = None
        self.industry_of_interest: List[str] = None
        self.asset_classes_of_interest: List[str] = None
        self.market_coverage: List[str] = None
        self.responsibility: List[str] = None
        self.function: List[str] = None
        self.instrument: List[str] = None
        self.id: str = None
        self.avatars: List[Avatar] = None
        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        return {
          'anyOf': [
          ],
          'allOf': [
              BaseProfile,
              ProfileAllOf,
          ],
          'oneOf': [
          ],
        }
